
#include <inarm.h>
#include "system.h"
#include "bits.h"
#include "nRF24L01.h"
#include <iolpc2148.h>
#include "const.h"


unsigned char ch;
unsigned int i = 0;
unsigned char config, dummy, var, payload;
extern unsigned char status;
unsigned char status_temp;
unsigned char but_flag = 0;

int main()
{

  // Frequenci init
  FreqInit();

  // System init
  SysInit();

  // Init SPI0 Interface
  SPI0Init();

  // Setting for nRF chip
  nRFSetting();

  // Claer variables
  i = 0;
  but_flag = 0;

  // loop forever
  while(1)
  {
    // Check button pressed
    if (((BUT)==0) && (but_flag==0))    {

      // Send one byte -> 0x45 -------------------------------------------------

      // Chip enable low
      CE_LOW();

      // Setting for TX device
      // Write CONFIG register -> 00001010 - CRC enable, power-up, TX
      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0A);

      // Send payload - send any data
      status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x45);

      // Pulse for CE -> starts the transmission.
      CE_HIGH();
      CE_LOW();

      // Read STATUS register
      status = SPI_Send_command_without_ADDR(NOP, NOP);

      // if exceed number of transmision packets
      if ((status & MAX_RT) != 0) {

        // Clear MAX_RT bit in status register
        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, (status|MAX_RT));

        // No communication event here
        // ....
      }

      // If packet sent on TX
      if ((status & TX_DS) != 0) {

        // Clear TX_DS bit in status register
        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, (status|TX_DS));

        // Your code here
        // ...
      }


      // If TX full
      if ((status & TX_FULL) != 0)  {

        // Flush TX FIFO (in TX mode)
        status_temp = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);

        // Your code here
        // ...
      }

      // End send one byte -> 0x45 ---------------------------------------------

      // Wait to receive one byte - must be 0x46 -------------------------------

      // Setting for RX device
      //Write CONFIG register -> 00001010 - CRC enable, power-up, RX
      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0B);

      // button was pressed - set flag
      but_flag=1;
    }

    // Clear if button is already not pressed
    if (((BUT)!=0) && (but_flag !=0)) {

      // Just simple delay
      Delay(BUT_TIME);

      // clear button flag
      but_flag = 0;
    }

    // Chip enable high
    CE_HIGH();

    // wait for receive signal - IRQ
    if ((IRQ)==0) {

      //Read STATUS status register
      status = SPI_Send_command_without_ADDR(NOP, NOP);

      // Set high when new data arrives RX FIFO
      if ((status & RX_DR) != 0) {

        // Chip enable low
        CE_LOW();

        //Read payload data
        payload=SPI_Send_command_without_ADDR(R_RX_PAYLOAD, NOP);

        // Clear RX_DR bit in status register
        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, (status|RX_DR));
      }

      // Check received data
      if (payload == 0x46)  {

        // Clear data
        payload = 0;

        // Do anything - turn on/off led
        if ((IO0PIN & BIT10) != 0)
          LED_ON;
        else
          LED_OFF;
      }
    }

  }
}






